Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Types.h	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Types.h	(revision 116)
@@ -0,0 +1,37 @@
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_Types_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_Types_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_execute_unit {
+namespace execute_unit {
+namespace functionnal_unit {
+
+typedef enum
+  {
+    FUNCTIONNAL_UNIT_SCHEME_GLOBAL_REGISTERFILE,
+    FUNCTIONNAL_UNIT_SCHEME_LOCAL_REGISTERFILE
+  } Tfunctionnal_unit_scheme_t;
+
+}; // end namespace functionnal_unit
+}; // end namespace execute_unit
+}; // end namespace multi_execute_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit.cpp	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit.cpp	(revision 116)
@@ -84,5 +84,18 @@
 	SC_METHOD (genMoore);
 	dont_initialize ();
-	sensitive << (*(in_CLOCK)).neg();
+	sensitive << (*(in_CLOCK)).neg(); // use internal register
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+
+	log_printf(INFO,Functionnal_unit,FUNCTION,"Method - genMealy");
+
+	SC_METHOD (genMealy);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg()  // use internal register
+//                << (*(in_EXECUTE_IN_VAL ))
+                  << (*(in_EXECUTE_OUT_ACK));
+
 	
 # ifdef SYSTEMCASS_SPECIFIC
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMealy.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMealy.cpp	(revision 116)
@@ -0,0 +1,53 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_execute_unit {
+namespace execute_unit {
+namespace functionnal_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Functionnal_unit::genMealy"
+  void Functionnal_unit::genMealy (void)
+  {
+    log_begin(Functionnal_unit,FUNCTION);
+    log_function(Functionnal_unit,FUNCTION,_name.c_str());
+
+    {
+      internal_EXECUTE_OUT_VAL = (reg_BUSY_OUT and (_execute_operation_out->_timing._latence == 0));
+      
+      PORT_WRITE(out_EXECUTE_OUT_VAL          , internal_EXECUTE_OUT_VAL);
+    }
+
+    {
+      internal_EXECUTE_IN_ACK = (not reg_BUSY_IN or
+                                 (reg_BUSY_IN and (not reg_BUSY_OUT or 
+                                                   (internal_EXECUTE_OUT_VAL and PORT_READ(in_EXECUTE_OUT_ACK)))));
+      
+      PORT_WRITE(out_EXECUTE_IN_ACK           , internal_EXECUTE_IN_ACK);
+    }
+
+    log_end(Functionnal_unit,FUNCTION);
+  };
+
+}; // end namespace functionnal_unit
+}; // end namespace execute_unit
+}; // end namespace multi_execute_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMoore.cpp	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMoore.cpp	(revision 116)
@@ -20,5 +20,5 @@
 
 #undef  FUNCTION
-#define FUNCTION "Functionnal_unit::genMealy"
+#define FUNCTION "Functionnal_unit::genMoore"
   void Functionnal_unit::genMoore (void)
   {
@@ -27,13 +27,4 @@
 
     {
-      internal_EXECUTE_IN_ACK = not reg_BUSY_IN;
-      
-      PORT_WRITE(out_EXECUTE_IN_ACK           , internal_EXECUTE_IN_ACK);
-    }
-
-    {
-      internal_EXECUTE_OUT_VAL = reg_BUSY_OUT and (_execute_operation_out->_timing._latence == 0);
-      
-      PORT_WRITE(out_EXECUTE_OUT_VAL          , internal_EXECUTE_OUT_VAL);
       if (_param->_have_port_context_id)
       PORT_WRITE(out_EXECUTE_OUT_CONTEXT_ID   ,_execute_operation_out->_context_id   );
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_transition.cpp	(revision 116)
@@ -58,4 +58,36 @@
 	  }
 	
+
+        if (reg_BUSY_IN and not reg_BUSY_OUT)
+//      if (not reg_BUSY_OUT_old or)
+	  {
+	    reg_BUSY_OUT = reg_BUSY_IN;
+	    reg_BUSY_IN  = false;
+
+	    _execute_operation_out->_timing        = _execute_operation_in->_timing       ;
+	    _execute_operation_out->_context_id    = _execute_operation_in->_context_id   ;
+	    _execute_operation_out->_front_end_id  = _execute_operation_in->_front_end_id ;
+	    _execute_operation_out->_ooo_engine_id = _execute_operation_in->_ooo_engine_id;
+	    _execute_operation_out->_packet_id     = _execute_operation_in->_packet_id    ;
+	    _execute_operation_out->_operation     = _execute_operation_in->_operation    ;
+	    _execute_operation_out->_type          = _execute_operation_in->_type         ;
+	    _execute_operation_out->_has_immediat  = _execute_operation_in->_has_immediat ;
+	    _execute_operation_out->_immediat      = _execute_operation_in->_immediat     ;
+	    _execute_operation_out->_data_ra       = _execute_operation_in->_data_ra      ;
+	    _execute_operation_out->_data_rb       = _execute_operation_in->_data_rb      ;
+	    _execute_operation_out->_data_rc       = _execute_operation_in->_data_rc      ;
+	    _execute_operation_out->_data_rd       = _execute_operation_in->_data_rd      ;
+	    _execute_operation_out->_data_re       = _execute_operation_in->_data_re      ;
+	    _execute_operation_out->_write_rd      = _execute_operation_in->_write_rd     ;
+	    _execute_operation_out->_num_reg_rd    = _execute_operation_in->_num_reg_rd   ;
+	    _execute_operation_out->_write_re      = _execute_operation_in->_write_re     ;
+	    _execute_operation_out->_num_reg_re    = _execute_operation_in->_num_reg_re   ;
+	    _execute_operation_out->_exception     = _execute_operation_in->_exception    ;
+	    _execute_operation_out->_no_sequence   = _execute_operation_in->_no_sequence  ;
+	    _execute_operation_out->_address       = _execute_operation_in->_address      ;
+	  }
+
+
+
 	// Test if push
 	execute_register_t * execute_register = NULL;
@@ -178,31 +210,4 @@
 	}
 
-	if (reg_BUSY_IN and not reg_BUSY_OUT)
-	  {
-	    reg_BUSY_OUT = reg_BUSY_IN;
-	    reg_BUSY_IN  = false;
-
-	    _execute_operation_out->_timing        = _execute_operation_in->_timing       ;
-	    _execute_operation_out->_context_id    = _execute_operation_in->_context_id   ;
-	    _execute_operation_out->_front_end_id  = _execute_operation_in->_front_end_id ;
-	    _execute_operation_out->_ooo_engine_id = _execute_operation_in->_ooo_engine_id;
-	    _execute_operation_out->_packet_id     = _execute_operation_in->_packet_id    ;
-	    _execute_operation_out->_operation     = _execute_operation_in->_operation    ;
-	    _execute_operation_out->_type          = _execute_operation_in->_type         ;
-	    _execute_operation_out->_has_immediat  = _execute_operation_in->_has_immediat ;
-	    _execute_operation_out->_immediat      = _execute_operation_in->_immediat     ;
-	    _execute_operation_out->_data_ra       = _execute_operation_in->_data_ra      ;
-	    _execute_operation_out->_data_rb       = _execute_operation_in->_data_rb      ;
-	    _execute_operation_out->_data_rc       = _execute_operation_in->_data_rc      ;
-	    _execute_operation_out->_data_rd       = _execute_operation_in->_data_rd      ;
-	    _execute_operation_out->_data_re       = _execute_operation_in->_data_re      ;
-	    _execute_operation_out->_write_rd      = _execute_operation_in->_write_rd     ;
-	    _execute_operation_out->_num_reg_rd    = _execute_operation_in->_num_reg_rd   ;
-	    _execute_operation_out->_write_re      = _execute_operation_in->_write_re     ;
-	    _execute_operation_out->_num_reg_re    = _execute_operation_in->_num_reg_re   ;
-	    _execute_operation_out->_exception     = _execute_operation_in->_exception    ;
-	    _execute_operation_out->_no_sequence   = _execute_operation_in->_no_sequence  ;
-	    _execute_operation_out->_address       = _execute_operation_in->_address      ;
-	  }
 	
 	// each cycle : decrease the latence
@@ -210,5 +215,5 @@
 	  _execute_operation_out->_timing._latence --;
       }
-
+    
 #if defined(STATISTICS) or defined(VHDL_TESTBENCH)
     end_cycle ();
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_vhdl.cpp	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_vhdl.cpp	(revision 116)
@@ -9,4 +9,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h"
 #include "Behavioural/include/Vhdl.h"
+#include "Behavioural/Generic/Shifter/include/Shifter.h"
 
 namespace morpheo                    {
@@ -25,4 +26,35 @@
   {
     log_printf(FUNC,Functionnal_unit,FUNCTION,"Begin");
+
+    morpheo::behavioural::generic::shifter::Parameters * param_shifter;
+    
+    param_shifter = new morpheo::behavioural::generic::shifter::Parameters
+      (
+       _param->_size_general_data,     // size_data
+       1,                     // nb_port
+       0,                     // shift_value
+       generic::shifter::external_rotate,       // rotate
+       generic::shifter::external_direction,    // direction
+       generic::shifter::external_carry,         // carry
+       false                 // type_completion_bool
+       );
+ 
+    morpheo::behavioural::generic::shifter::Shifter      * shifter;
+
+    std::string shifter_name = _name + "_shifter";
+    shifter = new morpheo::behavioural::generic::shifter::Shifter
+      (shifter_name.c_str()
+#ifdef STATISTICS
+       ,NULL
+#endif
+       ,param_shifter
+       ,USE_VHDL);
+    
+    _component->set_component(shifter->_component
+#ifdef POSITION
+                              , 50, 50, 50, 50
+#endif
+                              , INSTANCE_LIBRARY
+                              );
 
     Vhdl * vhdl = new Vhdl (_name);
